/* 
xkrs teletext display program.
NewsFleX is registered Copyright (C) <Jan Mourer>
email: jan@panteltje.demon.nl
snail mail: 
J.Mourer
Monnikebildtdijk 2
9078VE Oude Bildtzijl
Holland

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

 /*iic routines*/

/*i/o used:		parallel printer port for iic bus interface

/*scl			bit 7 0x378 =pin 9		(d7)				
/*sda pull down	bit 6 0x378 =pin 8		(d6)	 via si diode, anode on p15
/*sdain			bit 3 0x379 =pin 15		(ERROR)
*/

#include "sys_head.h"

#define PAR_PORT	0x378
#define IIC_BUS_DELAY	1

iibeep(da)/*beep and return 0 if error cannot be printed, else return 1*/
int da;/*device address*/
{
int a,i,j;
if((da == 34) || (da == 35)) a = 3;/*txt chip*/
if((da == 68) || (da == 69)) a = 2;/*ctrl chip*/
for(i = 0; i < a; i++)
	{
	usleep(500);
/*	beep(1,4000);
/*	delay(500);
*/   	}
return(1);
}

iicini()
{
sdah();
sclh();
}

busdly(d)
int d;
{
int i;
for(i=0;i<d;i++)
	{
	d=d;
	}
}

sdain()
{
/*char a;*/
/*int b;*/
register a;
a = inb(PAR_PORT + 1);
a &=  8;/*bit 3 only (ERROR signal on pin 15)*/
/*b = a;*/
/*return(b);*/
return(a);
}

iicstart()
{
sdal();
scll();
}

iicstop()
{
sdal();
sclh();
sdah();
}

sndbyte(d)
char d;
/*transmits one byte, scl must be low at start, scl is low at end*/
{
static char a,i;
a=d;
for(i=0;i<8;i++)/*each bit*/
	{
	if(!(a & 128))sdal();/*high bit first*/
	else sdah();
	a+=a;/*a=a*2*/
	sclh();
	scll();
	}
/*read ack bit*/
sdah();
sclh();
a=sdain();
scll();
if(a)return(0);/*no ack slave is error*/
return(1);/*ack slave is ok*/
}

rcvbyte(d,l)
char *d;
char l;/*last byte flag*/
{
static char b,i;
/*if last byte flag, then inverted ack bit is send,
/*scl must be low at start, scl is low at end
*/
sdah();/*for read*/
b=0;
scll();
for(i=0;i<8;i++)
	{
	sclh();
	b+=b;/*shift left*/
	if(sdain())b++;/*set bit 0*/
	scll();
	}
*d = b;
/*send ack bit*/
if(l)sdah();
else sdal();
sclh();
scll();
sdah();
return(1);/*always true, data in *d*/
}

iicsnd(a,n,d)/*address,annzahl,data array in ram*/
char a;
int n;
char d[];
{
static int i;
iicstart();
if(!sndbyte(a))
	{
	iicstop();
	printf("\niicsnd: No ack. device address %d\n",a);
	iibeep(a);
	return(0);
	}
for(i=0;i<n;i++)
	{
	if(!sndbyte(d[i]))
		{
		iicstop();
		printf("\niicsnd: No ack. data byte %d to device %d\n",d[i],a);
		iibeep(a);
		return(0);
		}
	}
iicstop();
return(1);/*ok*/
}

iicrcv(a,n,d)/*address,anzahl,data ptr to char array*/
char a;
int n;
char *d;
{
static int i;
char t[80];
iicstart();
/*write device address*/
if(!sndbyte(a))
	{
	iicstop();
	printf("\niicrcv: No ack. device address %d\n",a);
	iibeep(a);
	return(0);
	}
sdah();/*for read*/
for(i=0;i<n-1;i++)
	{
	rcvbyte(&d[i],0);
	}
rcvbyte(&d[i],1);
iicstop();
return(1);
}

scll()
{
register a;
a = inb(PAR_PORT);
a = a & 127;/*reset bit 7 (d7 on pin 9)*/
outb(a, PAR_PORT);
busdly(IIC_BUS_DELAY);
}

sclh()
{
register a;
a = inb(PAR_PORT);
a = a | 128;/*set bit 7 (d7 on pin 9)*/
outb(a, PAR_PORT);
busdly(IIC_BUS_DELAY);
}

sdal()
{
register a;
a = inb(PAR_PORT);
a = a & 0xbf;/*reset bit 6 (d6 on pin 8)*/
outb(a, PAR_PORT);
busdly(IIC_BUS_DELAY);
}

sdah()
{
register char a;
a = inb(PAR_PORT);
a = a | 0x40;/*set bit 6 (d6 on pin 8)*/
outb(a, PAR_PORT);
busdly(IIC_BUS_DELAY);
}

