/* 
xkrs teletext display program.
NewsFleX is registered Copyright (C) <Jan Mourer>
email: jan@panteltje.demon.nl
snail mail: 
J.Mourer
Monnikebildtdijk 2
9078VE Oude Bildtzijl
Holland

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/*xwindos version teletext and stock value aquisition program*/

#define XKRS_VERSION "Panteltje xkrs Version 1.0"

#include "sys_head.h"

#include "xkrs.h"
#include "display.h"
#include "keys.h"

/* pages holding program information, used for programming VCR */
/* this should be moved to a file */
/*                    today        tomorrow     day after tomorrow */
static int ppag[20]={ 201,202,203, 204,205,206, 207,208,209 }; /* page */
static int tcha[20]={ 1,  2,  3,   1,  2,  3,   1,  2,  3   }; /* channel */
static int sday[20]={ 0,  0,  0,   1,  1,  1,   2,  2,  2   }; /* days ahead */

static int mdays[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};
static char *month_name[]={"illegal","jan","feb","mrt","apr","mei","jun","jul",\
"aug","sep","okt","nov","dec"};
static char *day[]={"ma","di","wo","do","vr","za","zo"};


static int rdptr;
static int strtime[TIMERMAX],stptime[TIMERMAX],tchan[TIMERMAX];
static int strtday[TIMERMAX],stpday[TIMERMAX],lengthm[TIMERMAX];
static int strtmonth[TIMERMAX],stpmonth[TIMERMAX];
static int strtyear[TIMERMAX],stpyear[TIMERMAX];
static int timeptr;
static int total;
static int channel;
static int command[30];
static int vsm;
static int present_channel;
static int store_pages[STOREMAX];
static int store_subpages[STOREMAX];
static int store_channels[STOREMAX];
static int store_type[STOREMAX];
static int store_ptr;/*points in these arrays*/

static int position_change;	/*flag default reset, set if stock identifier not
						/*found in position specified in .krs file,
					   	/*if set, a search will be done in teletext for
					   	/*all following cals to function 35*/
static int cctreg[13];
static char icf[20];
static int lastfr,lastfw,flast;
static int rdfifl,oflag,fflag;
static unsigned checksum,rmode,smode,blockcnt,bytecnt;
static char ta[20],tc[20],td[20],ti[20],to[20],tp[40],tt[40],tsu[20];
static int devadd,cnt,bdly;
static int page, ival, ttime, subfro, subto, xfrmem, dspmem, acqcir, bank;
static int hour,minute,shour,sminute,ehour,eminutes;
static int mode,phour,pminute;
static int hold;

static int total;

static int prday,prmonth,pryear,wkday;/*present day, month, year and
											/*day in week (monday=0)*/

FILE *fy;
int audio_volume;


char *malloc();

char *displayname = NULL;
int level = 0;
int rows = 6, columns = 7;


#define TOPBORDERWIDTH 5
#define DEFAULTWIDTH	640
#define DEFAULTHEIGHT	480
#define MINWIDTH	640
#define MINHEIGHT	480

#define MINASPECTWIDTH	DEFAULTWIDTH
#define MINASPECTHEIGHT	(2 * DEFAULTHEIGHT)
#define MAXASPECTWIDTH	(2 * DEFAULTWIDTH)
#define MAXASPECTHEIGHT	DEFAULTHEIGHT

XSizeHints myhint;
XClassHint myclass;
XWMHints *mywmhints;


Colormap cmap;
int private_cmap = 0;
Cursor cursor_normal, cursor_q[4];

Pixmap qup, qupmask, qright, qrightmask, qdown, qdownmask, qleft, qleftmask;
XColor cursorforeground, cursorbackground;
int cursor_num;

#ifndef NO_SELECT
struct timeval selectval;
#endif

unsigned long valuemask;
XSetWindowAttributes attributes;


Pixmap iconpixmap;

char Title[] = XKRS_VERSION;
int c_index = 1, message_index = 0;

#define DEFAULTFONTPATTERN "*-Helvetica-Medium-R-Normal-*"
#define MAXFONTS 100
XFontStruct *fontstructarray[MAXFONTS];
int fontnum,  newposx, newposy,
    undoposx, undoposy, startposx, startposy, changeposx, changeposy;
int text1x, text2x, levely, humany, compy, movey;
int topwidth = 0, topheight = 0, boardwidth,
    buttonwidth, buttonheight, buttonspace,
    piece_dx, piece_dy, piece_width, piece_height;
int processing;

int *columnfill;

struct _rgb_vals
{
unsigned short red;
unsigned short green;
unsigned short blue;
}

color_values[8] = 
	{
		{     0,     0,     0 },	/* black*/	
		{ 65535,     0,     0 },	/* red */
		{     0, 65535,      0},	/* green */
		{     0,     0, 65535 },	/* blue */
		{     0, 65535, 65535 },	/* cyan (green + blue)*/
		{ 65535,     0, 65535 },	/* magenta (red + blue) */
		{ 65535, 65535,     0 },	/* yellow (red + green) */
		{ 65535, 65535, 65535 },	/* white (red + green + blue) */

	},
/* red = .3  green = .6  blue = .1 */
gray_values[8] = 
	{
		{     0,     0,     0 },	/* black 0 x 65535 */
		{ 19660, 19660, 19660 },	/* red .3 x 65535 */
		{ 39321, 39321, 39321 },	/* green .6 x 65535 */
		{  6553,  6553,  6553 },	/* blue .1 x 65535 */
		{ 45874, 45874, 45874 },	/* cyan (.6 + .1) x 65535 */
		{ 26214, 26214, 26214 },	/* magenta (.3 + .1) x 65535 */ 
		{ 58981, 58981, 58981 },	/* yellow (.3 +.6) x 65535 */
		{ 65535, 65535, 65535 },	/* white (.3 + .6 + .1) x 65535 */
	},
*rgb_values;

int font_cmp(p1, p2)
XFontStruct **p1, **p2;
{
  int ret = ((*p1)->max_bounds.rbearing + (*p1)->max_bounds.lbearing) -
	    ((*p2)->max_bounds.rbearing + (*p2)->max_bounds.lbearing);

  if (ret == 0)
    ret = ((*p1)->max_bounds.ascent + (*p1)->max_bounds.descent) -
	  ((*p2)->max_bounds.ascent + (*p2)->max_bounds.descent);
  return ret;
}

get_volume_from_ram_file(char id[], unsigned long *volume)
/* search for id in ramfile amongst volume entries there, and get volume */
{
int pag, subpag, xpos, ypos;
char iic_data[40];

/* normal x position of volume */
xpos = 32;
/* test if in ram, using dspmem 4, not in acq */
if(! test_if_in_ram(id, 4, &pag, &subpag, &ypos, VOLUME) )
	{
	return(0);/* not found */
	}
/* page now in dsp mem */
/* get the line at the y position found */
if(! pgetstr(xpos, ypos, 4, 40, iic_data) )return(0);/* hardware error */
/* make string terminator */
iic_data[39] = 0;
/* read the data from this line */
sscanf(iic_data, "%lu", volume);/* volume already a pointer */
return(1);/* found */
}

save_page_in_ram_file(int cctmem, int d_page, int d_subpage)
/* store page in ramfile, format as for function 93,
/* and update directory arrays.
*/
{
char iic_data[1024];
char temp[50];

/* range check */
if(store_ptr >= STOREMAX)
	{
	sprintf(temp, "Cannot store page, store directory full");
	print_in_display(cctmem, temp);
	return(1);
	}
/* get data */
if(! pgetstr(0, 0, cctmem, PAGLEN, iic_data) )return(0);/* hardware error */
/* make id */
sprintf(temp, "%3d%03d%1d", d_page, d_subpage, present_channel);
/* save in ram */
if(! data_to_ram(temp, iic_data) )
	{
	print_in_display(cctmem, "No more space in ram to store page");
	return(1);
	}
/* update pages directory */
store_pages[store_ptr] = d_page;
store_subpages[store_ptr] = d_subpage;
store_channels[store_ptr] = present_channel;/* global static */
store_ptr++;/*point to next position in directory*/
return(1);
}/* end function save_page_in_ramfile */

load_page_from_ram_file(int action, int entry, int dspmem_offsett)
/* reads a page from ram file into saa cctmem, action sets command */
{
char temp[80];
char pageid[20];
char iic_data[1024];
int cctmem;

/* range check */
if(store_ptr == 0)
	{
	print_in_display(0, "No pages stored in ramfile");
	return(1);
	}
/* always use first page (top left) */
if(dspmem_offsett == 0)cctmem= 0;
else cctmem = 4;
/* decide what to do */
if(action == FIRST)		rdptr = 0;
if(action == PREVIOUS)	if(rdptr > 0)rdptr--;
if(action == NEXT)		if(rdptr < (store_ptr - 1) )rdptr++;
if(action == LAST)		rdptr = store_ptr - 1;
if(action == THIS)		if( (entry >= 0) && (entry <= rdptr - 1) )rdptr = entry;
/* make id */
sprintf(pageid,  "%3d%03d%1d",\
store_pages[rdptr], store_subpages[rdptr], present_channel);
/* get the page */
if(! data_from_ram(pageid, iic_data) )
	{
	sprintf(temp,"\nCannot find page %s in ram file", pageid);
	print_in_display(0, temp);
	return(1);
	}
/* page to cct ram */
if(! tputpage(cctmem, iic_data) )return(0);/* hardware error */
/* print the info line */
sprintf(temp, "Item %d  page %d  subpage %d  MEMORY",\
rdptr + 1, store_pages[rdptr], store_subpages[rdptr]);
print_in_display(0, temp);
return(1);
}

test_video_signal(int *status)/*what it says*/
{
int signal_error;
int i;
printf("\nTesting video signal");
for(i = 0; i < 10; i++)/*try 10 times, with 500 msec intervals*/
	{
	if(! signstat(&signal_error) )
		{
		printf("\nCannot read Teletext signal status");
		return(0);/*error, status unknown*/
		}
	if( (signal_error & 3) == 3)/*bit 0 and 1 set*/
 		{
	 	printf("\nValid teletext signal");
		*status = 1;
		return(1);/*signal ok*/
		}
	if(! signal_error & 1)printf("\nVideo signal bad");
	if(! signal_error & 2)printf("\nTeletext signal bad");
	delay(500);/*wait for atmosferic conditions to change*/
	}/*end for testing video signal*/
*status = 0;
return(1);/*ok*/
}/*end function test_video_signal*/

update_csv_csw(\
char filebody[], int year, int month, int mtday, float closeprice, long volume,\
int volume_flag)
{
/*test if file exist*/
char stock[40];
char path[40];
FILE *csvcswfile;

get_path_name("stock_files_dir", path);
if(volume_flag)sprintf(stock,"%s%s.csw", path, filebody);
else sprintf(stock, "%s%s.csv", path, filebody);
/*test if file exists*/
csvcswfile = fopen(stock,"r");
if(csvcswfile)fclose(csvcswfile);	/*exists, not going to read, but append,
							/*using "a" would create new*/
else /*not existing, try to create a new file*/
	{
   	printf("\nCannot find file %s, creating it \n", stock);
   	csvcswfile = fopen(stock, "w");
  	if(!csvcswfile)/*no create*/
  		{
  		printf("\nCannot create file %s either\n", stock);
  		return(0);/*error*/
  		}
	/*created ok*/
	/* print the header, D stands for date (see following for format),
	/* C stands for closing price, V stands for volume */
	if(volume_flag)fprintf(csvcswfile, "DCV\n");/*print header*/
	else fprintf(csvcswfile, "DC\n");/*print header*/
	fclose(csvcswfile);/*close*/
	}
/*now we have for sure a csv file*/
/*append new data*/
csvcswfile = fopen(stock, "a");/*open for append*/
if(!csvcswfile)
	{
	printf("\nCannot append to file %s.csv\n", stock);
	return(0);
	}
/*file now open for append, update it*/
/*the format is mm/dd/yy,closeprice*/
if(volume_flag)
	{
	fprintf(csvcswfile, "%02d/%02d/%02d,%4.2f,%lu\n",\
	month, mtday, year % 100, closeprice, volume);
	}
else
	{
	fprintf(csvcswfile, "%02d/%02d/%02d,%4.2f\n",\
	month, mtday, year % 100, closeprice);
	}
fclose(csvcswfile);
return(1);
}

get_video_signal(int present_channel)
					/*test if teletext signal ok (video and teletext),
					/*and if not try to set vcr*/
{
int video_signal_status, power_mode, video_channel;
video_channel = present_channel;/*start here, step down after each try*/
power_mode = 0;/*status of power switch toggle on vcr*/
while(1)/*power button pushes*/
	{
	/*always, toggle channels*/
	/*vcr may be on AudioVideo, wrong channel, off, play.
	/*try to select valid channel*/
	video_channel = 3;
	while(1)/*try all video channels*/
		{
		/*test signal*/
		if(! test_video_signal(&video_signal_status) )return(0);/*error*/
		if(video_signal_status)return(1);/*video ok*/
		if(video_channel == 0)break;/*last one tested was channel 1*/
		if(video_channel == 3)/*first get it of audio video,
							/*if on AV, direct channel select does not work*/
			{
			printf("\nTrying to cancel AudioVideo mode");
			ir_remote_send("chan_up");/*should go to channel 1 if on AV*/
			}
		/*select a new channel*/
		printf("\nSelecting channel %d", video_channel);
		ir_send_two_digits(video_channel);/*select channel*/
		delay(500);/*wait .5 second for vcr to stabilize*/
		video_channel--;
		}/*end while try all channels*/
	/*vcr may be off, try the power switch (toggle)*/
	if(power_mode == 1)printf("\nRestoring previous power status of vcr");
	printf("\nTrying vcr power on / off switch");
	ir_remote_send("power");/*power is toggle, now on?*/
	video_channel = 3;
	printf("\nSelecting channel %d", video_channel);
	ir_send_two_digits(video_channel);/*select channel*/
	delay(1000);/*wait 1 second for vcr to stabilize*/
	power_mode++;
	if(power_mode == 2)break;/*0 is what it was, 1 reverse, 2 original status*/
	}/*end while power modes of vcr*/
return(0);/*error*/
}/*end function get_video_signal*/

calculator()/*a small calculator*/
{
char operator;
float foperand;
float fmemory;
float foldmemory1,foldmemory2;

fprintf(stderr, "\nCalculator, operators: q exit, u undo last, c clear, + - / *");
fprintf(stderr, "\nformat: float operator <ENTER>\n");
fmemory=0;
while(1)/*input operand and operator*/
	{
	fscanf(stdin,"%f%c",&foperand,&operator);
	foldmemory2=foldmemory1;/*save previous result*/
	foldmemory1=fmemory;/*save in case error*/
	if(operator == '+')fmemory += foperand;
	if(operator == '-')fmemory -= foperand;
	if(operator == '/')fmemory /= foperand;
	if(operator == '*')fmemory *= foperand;
	if(operator == 'c')fmemory=0;/*clear*/
	if(operator == 'u')fmemory=foldmemory2;/*undo last operation*/
	if(operator == 'q')break;
	fprintf(stderr, "\nmemory=%f\n",fmemory);
	}/*end while input operand and operator*/
return(1);
}

updateerrorfile(char *text)
{
FILE *errf;
char filename[40];
char path[40];

get_path_name("error_files_dir", path);
sprintf(filename, "%serrors.asc", path);
errf=fopen(filename, "a");/*create if not exist, update*/
if(!errf)
	{
	fprintf(stderr, "\nCannot update error file %s", filename);
	return(0);
	}
FP(errf,"\n%s",text);
fclose(errf);
return(1);
}

setdamo(m)/*set prday, prmonth and wkday from cctram m*/
int m;
{
int i;
int a,b;
char iic_data[40];
if(!pgetstr(24, 0, m, 2, iic_data))return(0);/*cannot read day*/
a=0;
b=0;
if(isdigit(iic_data[0]))a = iic_data[0];
if(isdigit(iic_data[1]))b = iic_data[1];
if((!a) && (!b))return(0);/*no day read*/
if((a) && (!b))prday = a - '0';
if((!a) && (b))prday = b - '0';
if((a) && (b))prday = 10 * (a - '0') + (b - '0');
if(!pgetstr(27, 0, m, 3, iic_data))return(0);/*cannot read month*/
iic_data[3] = 0;/*string term.*/
for(i = 0;i < 13;i++)
	{
	if(zindex(iic_data, month_name[i]) == 0)/*found month*/
		{
		prmonth=i;
		}
	}
if(!pgetstr(21, 0, m, 2, iic_data))return(0);/*cannot read day*/
iic_data[2] = 0;/*string term*/
for(i = 0; i < 7; i++)
	{
	if(zindex(iic_data, day[i]) == 0)/*found day*/
		{
		wkday=i;/*day in week, 0 for monday*/
		return(1);/*day and month and weekday set*/
		}
	}
return(0);/*month not found*/
}

get_path_name(char *request, char *reply)
/* reply is directory for requested type of file */
{
char temp[80];
FILE *inifile;
int a, i;
char filename[40];
int flags[10];
char idfield[40], contentfield[40];
char database_dir[40];
char macro_files_dir[40];
char ir_remote_command_files_dir[40];
char acq_command_files_dir[40];
char stock_files_dir[40];
char error_files_dir[40];

sprintf(filename, "/etc/xkrs/xkrs.ini");
inifile = fopen(filename, "r");
if(! inifile)
	{
	sprintf(temp, "NO OPEN %s, USING DEFAULTS", filename);
	print_in_display(0, temp);
	sleep(2);
	strcpy(database_dir, "/teletext/");
	strcpy(macro_files_dir, "/etc/xkrs/");
	strcpy(ir_remote_command_files_dir, "/etc/xkrs/");
	strcpy(acq_command_files_dir, "/etc/xkrs/");
	strcpy(stock_files_dir, "/etc/xkrs/");
	strcpy(error_files_dir, "/etc/xkrs/");
	}
else /* reading from /etc/xkrs.ini */
	{
	while(1)
		{
		a = fscanf(inifile, "%s %s", idfield, contentfield);
		if(a == EOF)break;
		if(zindex(idfield, "[database_files]") != -1)
			{
			strcpy(database_dir, contentfield);
			flags[0] =1;
			}
		if(zindex(idfield, "[macro_files]") != -1)
			{		
			strcpy(macro_files_dir, contentfield);
			flags[1] = 1;
			}
		if(zindex(idfield, "[ir_remote_command_files]") != -1)
			{
			strcpy(ir_remote_command_files_dir, contentfield);
			flags[2] = 1;
			}
		if(zindex(idfield, "[acq_command_files]") != -1)
			{
			strcpy(acq_command_files_dir, contentfield);
			flags[3] = 1;
			}
		if(zindex(idfield, "[stock_files]") != -1)
			{
			strcpy(stock_files_dir, contentfield);
			flags[4] = 1;
			}
		if(zindex(idfield, "[error_files]") != -1)
			{
			strcpy(error_files_dir, contentfield);
			flags[5] = 1;
			}		
		}/* end while read from file */
	for(i = 0; i < 6; i++)
		{
		if(flags[i] != 1)
			{
			sprintf(temp, "NO READ field %d", i);
			printf("\n%s\n", temp);
			}
		}
	fclose(inifile);
	}/* end reading from xkrs.ini */
/* reply */
if(zindex("database_files_dir", request) != -1)\
	strcpy(reply, database_dir);
else if(zindex("macro_files_dir", request) != -1)\
	strcpy(reply, macro_files_dir);
else if(zindex("ir_remote_command_files_dir", request) != -1)\
	strcpy(reply, ir_remote_command_files_dir);
else if(zindex("acq_command_files_dir", request) != -1)\
	strcpy(reply, acq_command_files_dir);
else if(zindex("stock_files_dir", request) != -1)\
	strcpy(reply, stock_files_dir);
else if(zindex("error_files_dir", request) != -1)\
	strcpy(reply, error_files_dir);
else if(inifile)/* error in xkrs.ini */
	{
	printf("\nget_path_name(): Error %s not found in /etc/xkrs/xkrs.ini\n",\
		request);
	if(index("database_files_dir", request) != -1)strcpy(reply, "/teletext/");
	else strcpy(reply,"/etc/xkrs/");/* use if error in inifile */
	}
return(1);
}


/*level 2 cct routines*/

clrstl(m)/*clear status line in dsp memory m, and put cursor on 0,24,dspmem*/
int m;
{
if(!tputstr(0,24,m,"                                        "))return(0);
														/*40 spaces*/
if(!tputcu(0,24,m))return(0);
return(1);
}

numinp(pv)/*read string into integer v, must be pointer*/
int *pv;
{
int a,c,i;
char temp[42];
char s[6];

if(fscanf(fy, "%5s", s) == EOF)
	{
	if(fy != stdin)/*cmd file open*/
		{
		fclose(fy);/*close command file*/
		sprintf(temp,"End of file on command file %s",icf);
		fprintf(stderr, "\n%s",temp);
		if(vsm == 1)
			{
			clrstl(dspmem);
			tputstr(0,24,dspmem,temp);
			}
		fy = stdin;/*read from console*/
		return(0);/*no data*/
		}
	return(0);/*no data*/
	}
c = s[0];
if(isalpha(c))
	{
	c = toupper(c);
	*pv = c;
	}/* end isalpha */
else
	{
	*pv = atoi(s);
	}
return(1);/*valid data*/
}

waitpag(int cctmem, int minutes)
/* wait untill page has arrived in cctram m, any key causes break and return 0,
/* if no page is found within t seconds, return 0 follows */
{
char temp [42];
int tenthseconds;

tenthseconds = minutes * 600;
while(! arrived(cctmem) )
	{
	delay(100);/*wait 100 milliseconds, try then again, return zero if minutes*/
	if(bdstat())
		{
		sprintf(temp,"Break detected");
		fprintf(stderr, "\n%s",temp);
		if(vsm ==1)
			{
			clrstl(dspmem);
			tputstr(0,24,dspmem,temp);
			}
		return(0);
		}
	tenthseconds--;
	if(tenthseconds == 0)/*time out*/
		{
		sprintf(temp,"Page not found");
		fprintf(stderr, "\n%s",temp);
		if(vsm == 1)
			{
			clrstl(dspmem);
			tputstr(0,24,dspmem,temp);
			}
		return(0);
		}
	}/*end while test for arrived*/
return(1);
}

acqstr(p,t,m)/*page,subpage or time*/
/*acq. page p subpage t, and write to disk as lastfw ext .tf
/*if time==0 ) auto subpages save, all subpages will be saved,
/*starting at the present one, until same subpage is read
/*if time is !0 only requested subpage is read*/
int p,t,m;
{
int o;/*previuos subpage memory*/
char s[20];
int a,b,c,i,u,q;
int frstsub;
o= -1;/*reset old subpage*/
if(t==0)a=0;
else a=1;
c=0;/*page cnt*/
while(1)
	{
	if(!acqpag(p,t,bank,m,a,0))return(0);
	/*page,time,bank,acqcir m,smode,hold 0*/
	clrstl(dspmem);
	fprintf(stderr, "Looking for page %d ",p);
	if(a)fprintf(stderr, "subpage %d",t);
	else fprintf(stderr, "all subpages");
	clrstl(dspmem);
	fprintf(stderr, "Any key to cancel search");
	if(!waitpag(m, 10))return(0);/*key pressed or not found in 10 minutes*/
	if(!getsupa(m,&u,&q))/*mem,subpage,page(dummy, not used)*/
		{
		clrstl(dspmem);
		fprintf(stderr, "Cannot read subpage or page\n");
		return(0);
		}
	if(c == 0)frstsub=u;/*save first pag read, to prevent doubles*/
	if((c != 0) && (o == u))
		{
		lastfw--;/*not first item, same subpag*/
		c--;	/*do not incr. count, file is overwritten by
			/* updated (corrected) one*/
		}
	if((c != 0) && (u == frstsub))return(1);/*round*/
	sprintf(s,"%d.tf",lastfw);

/*disabled because of incorrect double argument*/
/*	if(!savepag(m,s))
/*		{
/*		clrstl(dspmem);
/*		fprintf(stderr, "No more space to store page\n");
/*		return(0);
/*		}
/*	else lastfw++;
*/
	if(a)return(1);/*specific sub page*/
	if(u == 0)return(1);/*no subs*/
	clrstl(dspmem);
	fprintf(stderr, "item: %d  subpage %d  sequence %d \n",lastfw,u,c);
/*	if((c != 0) && (u == frstsub))/*page was already stored, round*/
/*		{
/*		store_ptr--;
/*		return(1);/*ready*/
/*		}
*/
	c++;
	o=u;
	}/*end while subpages*/
}

getprog()/*read program pages into cctram*/
{
int p,t;
int i,a;
int pg[5],tm[5];
pg[0]=101;
pg[1]=204;
pg[2]=205;
pg[3]=206;
tm[0]=0;
tm[1]=0;
tm[2]=0;
tm[3]=0;
for(i=0;i<4;i++)
	{
	if(!acqpag(pg[i],tm[i],bank,i,0,0))return(0);
	}
seldisp(dspmem);
return(1);
}

fndatime()
{
int i;
char s[41];
vidsel(1);
fprintf(stderr, "\nSearch string? ");
fscanf(fy,"%41s%[^\32]",s);
fprintf(stderr, "\nsearching for string %s\n",s);
for(i=1;i<4;i++)
	{
	if(!scanmem(i,s))continue;/*search next page if this one not found*/
	}
fprintf(stderr, "\nReady\n");
return(1);
}

scanmem(m,s)/*cct mem m, string s*/
int m;
char s[];
{
int fsp;/*first sub page*/
int psp;/*previous sub page*/
int a;
int c;
int p;/*pass same subpage*/
int q;/*page in getsupa(), dummy not used*/
c=0;
psp= -1;/*not a real value*/
p=0;
while(1)
	{
	if(bdstat())return(0);/*key*/
	if(!waitpag(m, 10))return(0);/*key pressed or not found in 10 minutes*/
	if(!getsupa(m,&a,&q))return(0);/*cctram,&subp,&pg cannot read subpage*/
	if(a == psp)
		{
		p++;
		if(p == 15000)return(0);/*30000 is approx 9.6 minutes*/
		/*same subpage transmitted all the time or signal loss*/
		continue;/*wait for a subpage change*/
		}
	if(( c != 0) && (a == fsp))return(1);/*round, already searched*/
	fprintf(stderr, "searching CCT memory %d, subpage %d\n",m,a);
	fndtime(m, 0, s, 0);/* first 0 is search whole page, last is from line 0 */
	psp=a;/*prev sub page =a*/
	if(a == 0)return(1);/*no subs*/
	if(c == 0)fsp=a;/*first subpage is a*/
	c++;
	}
}

fndtime(int m, int areaflag, char s[], int firstline)/*cctram, pointer in storec[],string*/
/*find time corresponding to program name in string s in memory m,
/*start search at line firstline, put it in phour and pminute
/*set timer with time found, set channel (depending on page)
*/
{
int a,b,i,j;
int sthp;/*start hour page*/
int stmp;/*start minute page*/
int sttp;/*start time page*/
int sf;
int lastline;/* last line */
char temp[40];
char iic_data[40];

ogettime(temp,temp,&b,&b,&b,&b,&pryear);/*only use year from pc*/

sf=0;/*stop time expected flag*/
lastline=25;
/* get start time of this page */
if(! gettvps(29, 3, &sthp, &stmp, m) )return(0);/* hardware error */
if(sthp == -1)
	{
	printf("\nCannot read VPS start of page\n");
	return(1);/* not a vps page */
	}
for(i = firstline; i < lastline; i++)
	{
	if(timeptr >= TIMERMAX)
		{
		fprintf(stderr, "Timers full\n");
		return(0);
		}
	/* get vps time on this line at x=8 */
	if(! getvps(8, i, &phour, &pminute, m) )return(0);/* hardware error */
	if(phour == -1)/* could not read vps field */
		{
		if( (i == 24) && (sf) )
			{
			/*use end time at top of screen if no endtime found*/
			if(! gettvps(35, 3, &phour, &pminute, m) )return(0);/*hardw. error*/
			if(phour == -1)
				{
				printf("\nCannot read VPS end of page\n");
				return(1);/* not a vps page */
				}
			}
		else continue;/*not a time containing line, scip*/
		}
	if(!sf)
		{
		if(!pgetstr(0, i, m, 40, iic_data))return(0);/*page m*/
		iic_data[41] = 0;/*end of string marker*/
		if((a = zindex(iic_data, s)) == -1)continue;/*str not in this line*/
		else
			{
			if(areaflag == 0)fprintf(stderr, "String %s: ",s);
			fprintf(stderr, "starttime=%d.%d  ",phour,pminute);
			strtime[timeptr]=phour*60+pminute;
			strtyear[timeptr]=pryear;/*no read txt*/
			stpyear[timeptr]=pryear;
			if(!setdamo(m))return(0);/*no read present day month*/
			strtday[timeptr]=prday;/*present day*/
			stpday[timeptr]=prday;
			strtmonth[timeptr]=prmonth;/*present month*/
			stpmonth[timeptr]=prmonth;
			if(!setchda(m))return(0);
				/*cannot update for days ahead*/
			/*updates tch[] strtday[] strtmonth[] strtyear[]*/
			/*stpday[] stpmonth[] stpyear[]*/
			sttp=sthp*60+stmp;/*start of page*/
			if(strtime[timeptr] < sttp)/*morning next day*/
				{
				strtday[timeptr]++;
				if(strtday[timeptr] > mdays[strtmonth[timeptr]])
					{
					strtday[timeptr]=1;
					strtmonth[timeptr]++;
					if(strtmonth[timeptr] > 12)
						{
						strtmonth[timeptr]=1;
						strtyear[timeptr]++;
						}
					}
				}
			/*stop parameters are at least equal to start
			/*parameters, but may be incremented later if
			/*stop time < start time, (timer goes over 2400 h)*/
			stpday[timeptr]=strtday[timeptr];
			stpmonth[timeptr]=strtmonth[timeptr];
			stpyear[timeptr]=strtyear[timeptr];
			sf=1;/*set stop time expected flag*/
			}
		}
	else/*sf=1*/
/* the next time found at start of line (next program start?) is stoptime*/
		{
		fprintf(stderr, "stoptime=%d.%d  ",phour,pminute);
		stptime[timeptr]=60*phour+pminute;
		if(stptime[timeptr] < strtime[timeptr])
			{
			stpday[timeptr]++;
			if(stpday[timeptr] > mdays[stpmonth[timeptr]])
				{
				stpday[timeptr]=1;
				stpmonth[timeptr]++;
				if(stpmonth[timeptr] > 12)
					{
					stpmonth[timeptr]=1;
					stpyear[timeptr]++;
					}
				}
			}
		sf=0;/*reset stop time expected flag*/
		if(wincheck())
			{
			fprintf(stderr, "chan %d  ",tchan[timeptr]);
			fprintf(stderr, "%d-%d-%d  ",\
			strtday[timeptr],strtmonth[timeptr],strtyear[timeptr]);
			timeptr++;
			gtotal(&total);
			fprintf(stderr, "timer %d  total %d\n",timeptr,total);
			}
		else 	fprintf(stderr, "time in use\n");
		if(areaflag == 1)return(1);/*single line only*/
		}
	}/*end for all lines*/
return(0);/*not found*/
}

wincheck()/*check if time used by other timers*/
{
int i;
unsigned bm,em,bmi,emi;
/*convert to unsigned integer representing minutes*/
/*max integer is 31*24*60 + 23*60 + 59, this is < 65535*/
bm=(24*60*strtday[timeptr])+strtime[timeptr];
em=(24*60*stpday[timeptr])+stptime[timeptr];
if(em==bm)return(0);/*zero time*/
for(i=0;i<timeptr;i++)
	{
	bmi=(24*60*strtday[i])+strtime[i];
	emi=(24*60*stpday[i])+stptime[i];
	if(bm>=emi)continue;/*starts on or after end of other timer*/
	if(em<=bmi)continue;/*stops at or before start of other timer*/
	/*this covers all possebileties, timers cannot be negative*/
	return(0);/*timer in window of other one, error, do not finish for*/
	}
lengthm[timeptr]=(em-bm);
return(1);
}

gtotal(int *total)/*get total minutes used by timer*/
{
int i;
*total = 0;
for(i = 0; i < timeptr; i++)
	{
	*total += lengthm[i];
	}
}

setchda(m)/*set tchan[timeptr] strtday[timeptr] strtmonth[timeptr]*/
int m;/*cct ram*/
{
int i;
int sp,pg;
if(!getsupa(m,&sp,&pg))return(0);/*cannot read page*/
for(i=0;i<20;i++)
	{
	if(pg == ppag[i])/*match*/
		{
		tchan[timeptr]=tcha[i];
		strtday[timeptr]=prday + sday[i];/*offset from present day*/
		if(strtday[timeptr] > mdays[prmonth])
			{
			strtday[timeptr]=strtday[timeptr]-mdays[prmonth];
			/*if mdays is 31, day is 31, and offset +2 then
			/*day would be 33. strtday= 33 - 31 = 2*/
			strtmonth[timeptr]++;
			if(strtmonth[timeptr] > 12)
				{
				strtmonth[timeptr]=1;
				strtyear[timeptr]++;
				}
			}
		return(1);/*found and set*/
		}
	}
return(0);/*error, page not found in setup*/
}

gettvps(int x, int y, int *vpshour, int *vpsminute, int cctmem)
/* uses format 12.12
/* get vps time at position x, y in cctram in vpshour and vps minute. 
/* returns hour and minute -1 if no vps field found.
*/
{
int i;
char iic_data[6];
if(! pgetstr(x, y, cctmem, 5, iic_data) )return(0); /* hardware error */
for(i = 0; i < 5; i++)
	{
	if(iic_data[i] == '.') continue;
	else if(! isdigit(iic_data[i]) )/* not a vps field */
		{
		*vpshour = -1;
		*vpsminute = -1;
		return(1); /* ok, but not a vps field */
		}
	iic_data[i] -= '0'; /* ASCII '0' to '9' to 0 to 9 */
	}
*vpshour = 10 * iic_data[0] + iic_data[1];
*vpsminute = 10 * iic_data[3] + iic_data[4];
return(1); /* ok */
}

getvps(int x, int y, int *vpshour, int *vpsminute, int cctmem)
/* uses format 1212
/* get vps time at position x, y in cctram in vpshour and vps minute. 
/* returns hour and minute -1 if no vps field found.
*/
{
int i;
char iic_data[5];
if(! pgetstr(x, y, cctmem, 4, iic_data) )return(0); /* hardware error */
for(i = 0; i < 4; i++)
	{
	if(! isdigit(iic_data[i]) )/* not a vps field */
		{
		*vpshour = -1;
		*vpsminute = -1;
		return(1); /* ok, but not a vps field */
		}
	iic_data[i] -= '0'; /* ASCII '0' to '9' to 0 to 9 */
	}
*vpshour = 10 * iic_data[0] + iic_data[1];
*vpsminute = 10 * iic_data[2] + iic_data[3];
return(1); /* ok */
}

xfndtime(int m, int firstline, char s[], int selected_display_page)
/*find time corresponding to program name in string s in memory m,
/*put it in phour and pminute,
/*set timer with time found, set channel (depending on page),
*/
{
int a,b,i,j;
int sthp;/*start hour page*/
int stmp;/*start minute page*/
int sttp;/*start time page*/
int stoptime_expected_flag;
int lastline;/*first line, last line*/
char temp[80];
char message[80];/* message to user accumulated here */
/* the following arrays are combined into a message to user */
char timer[10];
char string[80];
char channel[10];
char startdate[10];
char starttime[10];
char stoptime[10];
char length[10];
char totaltime[10];
char iic_data[40];
int x,y;

ogettime(temp, temp, &b, &b, &b, &b, &pryear);/*only use year from pc*/

stoptime_expected_flag = 0;
lastline = 25;/*use cursor line to buttom line for stoptime*/

/* get vps start time of this page*/
if(! gettvps(29, 3, &sthp, &stmp, m) )return(0);/* hardware error */
if(sthp == -1)
	{
	print_in_display(selected_display_page,\
	"Cannot read VPS start of page ");
	return(1);/* not a vps page */
	}
for(i = firstline; i < lastline; i++)/* all lines in display */
    {
    if(timeptr >= TIMERMAX)
  		{
	  	print_in_display(selected_display_page, "Timers full");
	  	return(1);
	  	}
	/* get VPS time on this line at x=8 */
	if(! getvps(8, i, &phour, &pminute, m) )return(0);/* hardware error */
	if(phour == -1)/* could not read vps field */
		{
		if( (i == 24) && (stoptime_expected_flag) )/* no end time found */
			{
			/*use end time at top of screen if no endtime found*/
			if(! gettvps(35, 3, &phour, &pminute, m) )return(0);/*hardw. error*/
			if(phour == -1)
				{
				print_in_display(selected_display_page,\
				"Cannot read VPS end of page ");
				return(1);/* not a vps page */
				}
			}/* end get vps end time from top screen */
		else continue;/*not a time containing line, scip*/
		}/* end get time on this line */
	if(!stoptime_expected_flag)
		{
		if(!pgetstr(0, i, m, 40, iic_data))return(0);/*page m*/
		iic_data[41] = 0;/*end of string marker*/
		if((a = zindex(iic_data, s)) == -1)continue;/*str not in this line*/
		else
			{
			if(firstline == 0)/* whole screen search */
				{
				sprintf(string, "string %s", s);
				}
			sprintf(starttime, "%02d.%02d", phour, pminute);
			strtime[timeptr] = phour * 60 + pminute;
			strtyear[timeptr] = pryear;/*no read txt*/
			stpyear[timeptr] = pryear;
			if(!setdamo(m))return(0);/*no read present day month*/
			strtday[timeptr] = prday;/*present day*/
			stpday[timeptr] = prday;
			strtmonth[timeptr] = prmonth;/*present month*/
			stpmonth[timeptr] = prmonth;
			if(!setchda(m))return(0);
				/*cannot update for days ahead*/
			/*updates tch[] strtday[] strtmonth[] strtyear[]*/
			/*stpday[] stpmonth[] stpyear[]*/
			sttp=sthp * 60 + stmp;/*start of page*/
			if(strtime[timeptr] < sttp)/*morning next day*/
				{
				strtday[timeptr]++;
				if(strtday[timeptr] > mdays[strtmonth[timeptr]])
					{
					strtday[timeptr] = 1;
					strtmonth[timeptr]++;
					if(strtmonth[timeptr] > 12)
						{
						strtmonth[timeptr] = 1;
						strtyear[timeptr]++;
						}
					}
				}
			/*stop parameters are at least equal to start
			/*parameters, but may be incremented later if
			/*stop time < start time, (timer goes over 2400 h)*/
			stpday[timeptr] = strtday[timeptr];
			stpmonth[timeptr] = strtmonth[timeptr];
			stpyear[timeptr] = strtyear[timeptr];
			stoptime_expected_flag = 1;/*set stop time expected flag*/
			}
		}
	else /*stoptime_expected_flag = 1*/
/* the next time found at start of line (next program start?) is stoptime*/
		{
		sprintf(stoptime, "%02d.%02d", phour, pminute);
		strcat(message, temp);
		stptime[timeptr] = 60 * phour + pminute;
		if(stptime[timeptr] < strtime[timeptr])
			{
			stpday[timeptr]++;
			if(stpday[timeptr] > mdays[stpmonth[timeptr]])
				{
				stpday[timeptr] = 1;
				stpmonth[timeptr]++;
				if(stpmonth[timeptr] > 12)
					{					stpmonth[timeptr] = 1;
					stpyear[timeptr]++;
					}
				}
			}
		stoptime_expected_flag = 0;/*reset stop time expected flag*/
		if(wincheck())
			{
			sprintf(channel, "%1d", tchan[timeptr]);
			/* year printed short because of restricted space on screen for
			/* message */
			sprintf(startdate, "%02d-%02d-%02d",\
			strtday[timeptr], strtmonth[timeptr], strtyear[timeptr] % 100);
			sprintf(length, "%d", lengthm[timeptr]);/* set in wincheck */
			timeptr++;
			gtotal(&total);
		    sprintf(timer, "%d", timeptr);
			sprintf(totaltime, "%d", total);
			strcat(message, temp);
			}/*end if wincheck*/
		else  /* ! wincheck */
			{
			print_in_display(selected_display_page, "Time in use");
			if(firstline != 0)return(1);
			}
		/* combine data for message to user */
		print_in_display(selected_display_page, message);
		/* only 40 characters, length dropped from report */
		sprintf(message, "timer:%s ch:%s %s %s %s to:%s",
		timer, channel, startdate, starttime, stoptime, totaltime);
		print_in_display(selected_display_page, message);
		if(firstline != 0)return(1);/* found , do not search other lines */
		}/* end if stoptime_expected_flag = 1 */
	}/* end for all lines */
print_in_display(selected_display_page, "Not found");
return(1);/* not found */
}

vcr_prog()/*program samsung vcr sv31xk using qprog system via ir remote*/
{
int i;
int channel, starthour, startminute, stophour, stopminute, startday;

for(i = 0; i < timeptr; i++)
	{
	channel = tchan[i];
	starthour = strtime[i] / 60;
	startminute = strtime[i] % 60;
	stophour = stptime[i] / 60;
	stopminute = stptime[i] % 60;
	startday = strtday[i];
	if(!qpro_vcr(\
	channel, starthour, startminute, stophour, stopminute, startday))
		{
		return(0);
		}
	}
return(1);
}

acq_to_ram(int present_channel, int requested_page, int requested_subpage,\
int acqcir, int type)
/*acq. page, subpage, add to directory array, and hang in ramfile
/*if subpage == 0 all subpages will be loaded,
/*starting at the present one, until same subpage is read,
/*if subpage is ! 0 only requested subpage is read*/
{
char s[20];
int dspmem;
int timed_page_flag, pagecnt, received_page;
int first_subpage, prev_subpage, received_subpage;
int a, b;
char iic_data[1024];

if(bank = 0)dspmem = acqcir;
if(bank = 1)dspmem = acqcir + 4;
prev_subpage = -1;/*reset old subpage*/
if(requested_subpage == 0)timed_page_flag = 0;
else timed_page_flag = 1;
pagecnt = 0;/*page cnt*/
printf("\nLooking for page %d ",requested_page);
if(timed_page_flag)printf("subpage %d", requested_subpage);
else printf("all subpages ");
/*printf("\n");*/
while(1)
	{
	/*page,time,bank,acqcir m,smode,hold 0*/
	if(!acqpag(requested_page, requested_subpage, bank, acqcir,\
	timed_page_flag, 0))return(0);
	if(!waitpag(dspmem, 10))return(0);/*key pressed or not found in 10 minutes*/
	if(!getsupa(dspmem, &received_subpage, &received_page))
		{
		printf("\nCannot read subpage or page\n");
		return(0);
		}
	if( (received_subpage == 0) && (prev_subpage != -1) )
	/*there was already a previous subpage, so there must be more then one
	/*subpage.
	/*sometimes error in read, do not know why*/
		{
		continue;/*do not use, invalid data*/
		}
	if(pagecnt == 0)first_subpage = received_subpage;	/*save first pag read,
														/* to prevent doubles*/
	/*scrn cctram m to iic_data*/
	if(!pgetstr(0, 0, dspmem, PAGLEN, iic_data))return(0);
	if(store_ptr == STOREMAX)
		{
		printf("\nCannot store page, store directory full\n");
		return(0);
		}
	if((store_ptr != 0) && (prev_subpage == received_subpage))
		{
		store_ptr--;/*not first item, same subpage*/
		pagecnt--;/*do not incr. count*/
		}
/*	if same page and subpage request or same page and subpage read more
/*	then once, data_to_ram will replace the present definition of string s with
/*	the new one*/
	store_pages[store_ptr] = requested_page;
	store_subpages[store_ptr] = received_subpage;/*real subpage*/
	store_channels[store_ptr] = present_channel;
	store_type[store_ptr] = type;
	sprintf(s,"%3d%03d%1d",
	store_pages[store_ptr], store_subpages[store_ptr],\
	store_channels[store_ptr], present_channel);
/*	printf("\nstoring %s", s);*/
	store_ptr++;/*point to next position in directory*/
	if(! data_to_ram(s, iic_data) )
		{
		printf("\nNo more space in ram to store page\n");
		return(0);
		}
	if(timed_page_flag)return(1);/*specific sub page found*/
	printf(\
	"item: %d  page %d  subpage %d  subpages read %d,  any key to cancel search\n",\
	store_ptr, requested_page, received_subpage, pagecnt + 1);
	if(received_subpage == 0)return(1);/*no subpages, ready*/
	if((pagecnt != 0) && (received_subpage == first_subpage))
										/*page was already stored, round*/
		{
		store_ptr--;
		return(1);/*ready*/
		}
	pagecnt++;
	prev_subpage = received_subpage;
	}/*end while reading subpages*/
}

int test_if_in_ram(\
char descr[], int dspmem, int *page, int *subpage, int *row, int type)
/*checks if descr is present anywhere in entries in RAM file,
/*if so loads the relevant page in the dspmem,
/*returns with page and subpage and row pointing to descr.
/*note that this data is absolute, it exactly gives the position in teletext
*/
{
int a;
int i, j;
char ta[20];
char defi[1024];
char temp[80];
char id[41];
char c;
static char iic_data[1024];

if(!store_ptr)
	{
	printf("\nNo pages stored in ramfile");
	return(0);
	}
/*to uppercase with descr*/
i = 0;
while(1)
	{
	c = descr[i];
	if(c == '_') c = ' ';
	id[i] = toupper(c);
	if(c == 0)break;/*end of string*/
	i++;
	}
printf("\nLooking for %s", id);
for(i = 0; i <  store_ptr; i++)
	{
	if(type != ALL)/* looking for a specific type */
		{
		if(store_type[i] != type)continue;/* not looking for this */
		}
	printf("\nIn entry %d",  i + 1);
	/*construct name of element in hash table*/
	sprintf(ta, "%3d%03d%1d",\
	store_pages[i], store_subpages[i], present_channel);
	/*get element from hash table*/
	if(! data_from_ram(ta, iic_data) )
		{
		printf("\nEntry %s not found in ramfile", ta);
		return(0);
		}
	/* convert data in ram file to upper case*/
	for(j = 0; j < PAGLEN; j++)		/* iic_data may contain zeros */
		{
		c = iic_data[j];
		if(c == 0)c = ' '; /* remove any zero's */
		defi[j] = toupper(c);  
		}
	/*check if id present in this page (char string)*/
	a = zindex(defi,  id);
	if(a != -1)/*found*/
		{
		/*page to dspmem*/
		if(! tputpage(dspmem, iic_data) )return(0);/*error*/
		/*status line info to dspmem*/
		if(! clrstl(dspmem) )return(0);/*error*/
		sprintf(temp,"Item %d  page %d  subpage %d",\
		i + 1, store_pages[i], store_subpages[i]);
		if(! tputstr(0, 24, dspmem, temp) )return(0);/*error*/
		/*update page and subpage*/
		*page = store_pages[i];
		*subpage = store_subpages[i];
		/*determine row*/
		*row = a / 40;/*40 characters / row*/
		printf("\n%s  row %d",temp, *row);
		return(1);/*found*/
		}/*end if string in this RAM entry*/
	}/*end for all entries in RAM*/
printf("\n%s not found in ramfile\n", id);
return(0);/*not found in RAM store*/
}

put_volume_pages_into_ram_file()
/* get pages specifies in file 'pages.dat', and store in ram file,
/* use acqcir dspmem
*/
{
FILE *vpagesfile;
int ch, pg, spg;
int cctmem;
char filename[40];
char path[40];

get_path_name("acq_command_files_dir", path);
sprintf(filename, "%svpages.dat", path);
vpagesfile = fopen(filename, "r");
if(!vpagesfile)
	{
	printf(\
	"\nCannot open file %s, cannot read volume pages into ram file\n",\
		filename);
	return(0);
	}
/* the format of all entries in file vpages.dat is channel, page, subpage */
while(1)/* for all entries in vpages.dat */
	{
	if( fscanf(vpagesfile, "%d %d %d", &ch, &pg, &spg) == EOF)
		{
		fclose(vpagesfile);
		return(1);/*ok*/
		}
	/* do not overwrite pages read, use bank 1, acqcir 1 = dspmem 1.
	/* acqcir 0 = dspmem 0 is in use for read from ram, else no acq
	/* because already there.
	*/
	bank = 1;
	if(! acq_to_ram(ch, pg, spg, dspmem, VOLUME) )
		{
		bank = 0;
		fclose(vpagesfile);
		return(0);/*error*/
		}
	bank = 0;
	}/*end while for all entries in pages.dat*/
}/* end function put_volume_pages_into_ram_file */

put_pages_into_ram_file(int dspmem)
/*get pages specifies in file 'pages.dat', and store in ram file,
use acqcir dspmem*/
{
FILE *pagesfile;
int ch, pg, spg;
char temp[40];
char filename[40];
char path[40];

get_path_name("acq_command_files_dir", path);
sprintf(filename, "%spages.dat", path);
pagesfile = fopen(filename, "r");
if(!pagesfile)
	{
	printf("\nCannot open file %s, cannot read pages into ram file\n",\
		filename);
	return(0);
	}
store_ptr = 0;/*clear ram file, reset store pointer (global static)*/
/*the format of all entries in file pages.dat is channel, page, subpage*/
while(1)/*for all entries in pages.dat*/
	{
	if(fscanf(pagesfile, "%d %d %d", &ch, &pg, &spg) == EOF)
		{
		fclose(pagesfile);
		return(1);/*ok*/
		}
	if(! acq_to_ram(ch, pg, spg, dspmem, CLOSE_PRICE) )
		{
		fclose(pagesfile);
		return(0);/*error*/
		}
	}/*end while for all entries in pages.dat*/
}/* end function put_pages_into_ram_file */

acqoff()/*acquisition off and free run pll*/
{
cctreg[0] |= 64;/*set free run pll bit*/
cctreg[1] |= 32;/*set acq off bit*/
cctreg[5]=63 + 192;/*teletext only video select mode*/
cctini();
}

acqon()/*acquisition on and normal sync pll*/
{
cctreg[0] &= ~64;/*reset free run pll bit*/
cctreg[1] &= ~32;/*reset acq off bit*/
cctini();
}

cctini()
{
char iic_data[20];

iic_data[0] = 0;
iic_data[1] = cctreg[0];		/* select r11 i.p.v. r11b */
if(! iicsnd(34, 2, iic_data) )return(0);
iic_data[0] = 1;
iic_data[1] = cctreg[1];		/* tcs on mode 0 (+128 for video to sync output) */
iicsnd(34, 2, iic_data);
iic_data[0] = 4;
iic_data[1] = cctreg[4];		/* display mem */
iicsnd(34, 2, iic_data);
iic_data[0] = 5;
iic_data[1] = cctreg[5];
/*128*bkgnd out+64*bkgnd in+32*cor out+8*text out +4*text in+2*pon out+pon in*/
/*no blanking, teletext video, teletext*/
iicsnd(34, 2, iic_data);
iic_data[0] = 6;/*r6*/
iic_data[1] = cctreg[6];		/* 32(cor out) 16(cor in) 4(text in box) */
if(! iicsnd(34, 2, iic_data) )return(0);
iic_data[0] = 7;
iic_data[1] = cctreg[7];		/* 64(cursor on) 4{box24) 2(box123) box */
iicsnd(34, 2, iic_data);
return(1);
}

seldisp(m)/*select display memory m*/
int m;
{
cctreg[4] = m;
cctini();
/*iicdat[0]=4;/*r4*/
/*iicdat[1]=m;/*display chapter*/
/*if(!iicsnd(34,2,iicdat))return(0);*/
return(1);
}

vidsel(s)/*select video source, teletext or computer*/
int s;
{
if(s==5)/*clear screen*/
	{
/*	if(vsm==0)vga_clear();
/*	pgcls();
/*	fprintf(stderr, "%c[2J",27);/*ANSI CLEAR SCREEN*/
/*	else
*/
	if(!tcls(dspmem))return(0);
	return(1);
	}
if(s==1)
	{
	if(!updctrl(1,1))return(0);/*select computer, set bit 1 control port*/
	vsm=0;
	return(1);
	}
else 
	{
	if(!updctrl(1,0))return(0);/*select txt, reset bit 1 control port*/
	vsm=1;
	}
if(s==2)/*teletext*/
	{
	cctreg[1]=4;
	cctreg[5]=63 + 192;
	}
if(s==3)/*teletext + picture*/
	{
	cctreg[1]=0;/*tcs off*/
	cctreg[5]=63 + 192;
	}
if(s==4)/*picture*/
	{
	cctreg[1]=0;
	cctreg[5]=51 + 192;
	}
if(!cctini())return(0);
if(!seldisp(dspmem))return(0);
return(1);
}

waitunti(sc)/*wait untill time specified, then continue*/
int sc;/*0 if no weekday check, 1 if mo trough fr*/
{
int c,h,m;
unsigned int a,b;
int k,k2;
vidsel(1);/*normal screen*/
fprintf(stderr, "\nTime to continue? ");
numinp(&a);
while(1)
	{
	fprintf(stderr, "\nWaiting untill %d.%02d ",a / 100,a % 100);
	if(sc)fprintf(stderr, " monday to friday  ");
	k=bdstat();
	if(k)/*key presed*/
		{
/*		k2=getkey();
/*		if(k2 == 26)/*test for ^z*/
			{
			fprintf(stderr, "\nBreak detected\n");
			return(0);
			}
		}	
	if(!signstat(&c))
		{
		fprintf(stderr, "cannot read signal status");
		continue;
		}
	if(!(c & 1))
		{
		fprintf(stderr, "video signal bad");
		continue;
		}
	if( ! ( (c >> 1) & 1) )
		{
		fprintf(stderr, "text signal bad");
		continue;
		}
	if(!getclk(32,0,&h,&m,dspmem))
/*Note: its seems that SAA chip only updates clock in dspmem, in other mem
/*the clock stops, so if dspmem=2 you cannot read the time from dspmem 0
/*for example, that time is the time any other dspmem then 0 was selected*/
		{
		fprintf(stderr, "cannot read time");
		continue;
		}
	fprintf(stderr, "time=%d.%02d  ",h,m);
	if(sc)/*wait until mo,tu,we,th,fr, continue sa and su*/
		{
		if(!setdamo(dspmem))
			{
			fprintf(stderr, "cannot read week day");
			continue;
			}
		fprintf(stderr, "day= %s",day[wkday]);
		if(wkday > 4)/*sa and su*/
			{
			continue;
			}
		}
	b=100 * h + m;
	if(b == a)
		{
		fprintf(stderr, ", end of wait\n");
		return(1);/*time corr.*/
		}
	}
}

holdp()/*hold page*/
{
if(bank == 0)
	{
	if(dspmem > 3)return(1);/*no hold needed*/
	}
if(bank == 1)
	{
	if(dspmem < 4)return(1);/*no hold needed*/
	}
acqpag(page, ttime, bank, acqcir, smode, 1);/*hold=1*/
return(1);
}

bdstat()/*bdos status check only if reading from con*/
{
if(fy != stdin)/*reading from file, via scanf*/
	{
	return(0);
	}
/*
return(kbhit());
*/
return(0);/*____*/
}

svpag(char iic_data[])
{
int i;
char temp[80];
char c;
FILE *outfile;
char filename[40];
char path[40];

clrstl(dspmem);
fprintf(stderr, "Output filename? ");
fscanf(fy, "%12s", temp);
if(zindex(temp,".") == -1)strcat(temp, ".txt");
get_path_name("database_files_dir", path);
sprintf(filename, "%s%s", path, temp);
/*test if file already exists*/
outfile = fopen(filename,"rb");
if(outfile)/*exists*/
	{
	fprintf(stderr, "\nFile '%s' already exists, overwrite? (y/n) ", filename);
	fclose(outfile);
	fscanf(fy, "%1s", temp);
	c = temp[0];
	c = toupper(c);
	if(c != 'Y')return(0);
	}
outfile = fopen(filename, "wb");
if(! outfile)
	{
	fprintf(stderr, "Cannot open output file %s\n", filename);
	return(0);
	}
for(i = 0; i < PAGLEN; i++)
	{
	putc(iic_data[i], outfile);
	}
fclose(outfile);
fprintf(stderr, "\nReady\n");
return(1);
}

loadpag(int m)/*puts file into cct ram m*/
{
char temp[80];
char filename[40];
char path[40];
char iic_data[1024];

PF("\nInput filename? ");
fscanf(fy, "%12s", temp);
if(zindex(temp,".") == -1)strcat(temp, ".txt");
get_path_name("database_files_dir", path);
sprintf(filename, "%s%s", path, temp);
holdp();
vidsel(2);
tcls(dspmem);/*clear page*/
iic_data[0] = 8;
iic_data[1] = m;/*memory*/
iic_data[2] = 0;/*start line*/
iic_data[3] = 0;/*start column*/
if(!iicsnd(34, 4, iic_data))return(0);
/*load iic_data[] from disk*/
if(!ldpag(filename, iic_data) )
	{
	vidsel(1);
	PF("\nCannot open file '%s' for read", filename);
	return(0);
	}
iic_data[0] = 11;/*r11, data in iic_data[1] to iic_data[PAGLEN + 1]*/
/*write array iic_data[] to cct ram*/
if(!iicsnd(34, PAGLEN + 1, iic_data))return(0);
return(1);
}

display_select(int key)
{
switch(key)
	{
	case GREY_PAGE_UP:
		if(dspmem < 7)
			{
			dspmem++;
			seldisp(dspmem);
			}
		break;
	case GREY_PAGE_DOWN:	/*saa dspmem down */
		if(dspmem > 0)
			{
			dspmem--;
			seldisp(dspmem);
			}
		break;
	case GREY_HOME:/* saa dspmem 0, acquisition circuit 0,  bank 0 */
		dspmem=0;
		acqcir=0;
		bank=0;
		seldisp(dspmem);
		break;
	}/* end switch key */
return(1);
}/* end function display_select */

get_saa_dspmem(int *saa_dspmem)/* could not get global statics working in make */
{
*saa_dspmem = dspmem;
return(1);
}/* end function get_saa_dspmem */

get_saa_bank(int *saa_bank)
{
*saa_bank = bank;
return(1);
}

set_saa_bank(int saa_bank)
{
bank = saa_bank;
return(1);
}

get_time_ptr(int *time_ptr)
{
*time_ptr = timeptr;
return(1);
}

set_time_ptr(int time_ptr)
{
timeptr = time_ptr;
return(1);
}

void change_cursor()
{
if (cursor_num == 3) cursor_num = 0;
else cursor_num++;
XDefineCursor(mydisplay, topwindow, cursor_q[cursor_num]);
}

void write_prog(ch)
char ch;
{
if (processing) XBell(mydisplay, 0);
else
	{
	processing = 1;
	cursor_num = 0;
	XDefineCursor(mydisplay, topwindow, cursor_q[0]);
	}
}

void message(newindex)
int newindex;
{
message_index = newindex;
}


void recalculate(width, height)
int width, height;
{
int i, j, fontid, d1, d2, d3, maxtextwidth, maxtextheight;
XCharStruct tmpsize;

if (width == topwidth && height == topheight) return;
topwidth = width;
topheight = height;
}


int main(argc, argv)
int    argc;
char **argv;
{
/*
char *av[4], row_string[3], column_string[3];
*/
float fa,fb,fc,fd,fe,fg,fh;
float fmaxk,fmink,maxval,minval,difval,prevval,lasval;
int lic1;/*retry cnt*/
int lic2;/*reinitiate cnt*/
int lic3;/*clear accumulation array cnt*/
int xpos,ypos,lenfie,lenfr;
int row;
int value;
float trend;
int xflag;
int xdeflag;
int xcnt;
int i,j,k;
int a,b,c,d,e,f,g,h;
int pg,sp,af;/*page subpage acq flag*/
int pp,ps;/*present page, present subpage*/
int lstacq;/*last acq circuit used*/
int ctfl;/*check text flag for getmoney, 1=check*/
FILE *krsf;
FILE *krsfb;
FILE *erep;
int units,fract;
int emode;
int stat;
int slow;
int sv;/*scanf return value*/
char si[20];/*scanf input string*/
char filebody[20];/*read by scanf, aab in aab.krs or aab.csv or aab.csw*/
char comstr[21];/*comment string for .krs file*/
char monstr[11];/*month string for .krs file*/
char oldmonth[12];
int oldyear;
int x,y,yr;
char temp[80];
int special_field_appended_flag;/*case 35*/
char iic_data[1024];
int hpos[8];
int vpos[8];
int video_signal_status;

/*for function 96 test limits*/
char stock[10];
float flmax,flmin;

/* last update date of stockfile in case 35 */
char fiwd[3];/*weekday in header stockfile*/
char fimo[5];/*month in header stockfile*/
int fida;/*day in header stockfile*/
int datereadflag;
int datecheck;
int satsuncheck;
int rangecheck;

/*for home control system programming (video) function 28 and 29*/
int comport;
long baudrate;
long la;

/*for .csv and .csw type files update in case 35*/
int year;
float openprice, closeprice, maximumprice, minimumprice;
unsigned long volume;
int volume_pages_loaded_in_ram_file_flag;

/*used by s3 ini, further on*/
/*char palette[256][3];*/

/* for function 'Y' split stock file */
float multiplic_factor;
int userx, usery, userwidth, userheight;

/* set io permissions */
ioperm(0x40, 0x3bf, 1);

/*defaults set here*/
present_channel = 3;
bank=0;
slow=1;/*define for toggle, pcf8574 sets output to 1 on power up, slow*/
vsm=0;/*computer screen selected*/
ctfl=1;/*do check text field in get money*/

lstacq=0;/*start somewhere defined*/

cctreg[0]=0;
cctreg[1]=4;
cctreg[4]=0;
cctreg[5]=63 + 192;/* background in */
cctreg[6]=54;
cctreg[7]=71;


comport=4;
baudrate=4800;

datecheck = 1;
satsuncheck = 1;
rangecheck = 0;
position_change = 0;/*flag, if set, indicates that stock value ident string
/*was not found at position specified by .krs file.
/*From then on a search is made in teletext for every call to
/*function 35, using the pages specified in file pages.dat*/
volume_pages_loaded_in_ram_file_flag = 0;

audio_volume = 70; 

/*end defaults setting*/


mydisplay = XOpenDisplay(displayname);
if(! mydisplay)
	{
	fprintf(stderr, "%s: Couldn't open display.\n", displayname);
	exit(1);
	}

myscreen = DefaultScreen(mydisplay);

valuemask = 0;

a = DefaultDepth(mydisplay, myscreen);
if(a == 1)	
	{
	WHITE = YELLOW = RED = GREEN = BLUE = MAGENTA = CYAN =\
		 WhitePixel(mydisplay, myscreen);
	BLACK = BlackPixel(mydisplay, myscreen);
	}
else
	{
	Visual *vis = DefaultVisual(mydisplay, myscreen);
	if (vis->class == GrayScale || vis->class == StaticGray ||
														vis->map_entries < 5)
		{
		rgb_values = gray_values;
		}
    else
		{
		rgb_values = color_values;
		}
	cmap = DefaultColormap(mydisplay, myscreen);
	for (i = 0; i < 8; i++)
		{
		XColor color;
		color.red   = rgb_values[i].red;
		color.green = rgb_values[i].green;
		color.blue  = rgb_values[i].blue;
		color.flags = DoRed | DoGreen | DoBlue;
		retry:
		if (XAllocColor(mydisplay, cmap, &color) == 0)
			{
			if (!private_cmap)
				{
				private_cmap = 1;
				cmap = XCopyColormapAndFree(mydisplay, cmap);
				goto retry;
				}
			else
				{
				fprintf(stderr, "%s: Couldn't allocate color %d\n", *argv, i);
				exit(2);
				}
			}
		PixelArray[i] = color.pixel;
		}/* end for */
    if (private_cmap)
		{
		attributes.colormap = cmap;
		valuemask |= CWColormap;
		}
	}/*end else default depth display */


attributes.background_pixel = BLACK;
valuemask |= CWBackPixel;
attributes.border_pixel = BLACK;
valuemask |= CWBorderPixel;
attributes.cursor = cursor_normal = XCreateFontCursor(mydisplay, XC_hand2);
valuemask |= CWCursor;
attributes.event_mask = ButtonPressMask | KeyPressMask | ExposureMask | StructureNotifyMask;
valuemask |= CWEventMask;
attributes.do_not_propagate_mask = ButtonPressMask;
valuemask |= CWDontPropagate;
  
myhint.width = DEFAULTWIDTH;
myhint.height = DEFAULTHEIGHT;
myhint.flags = PSize;

myhint.x = (DisplayWidth(mydisplay, myscreen) - myhint.width) / 2;
myhint.y = (DisplayHeight(mydisplay, myscreen) - myhint.height) / 2;
myhint.flags |= PPosition;

topwindow = XCreateWindow(mydisplay, DefaultRootWindow(mydisplay),
			    myhint.x, myhint.y, myhint.width, myhint.height,
			    TOPBORDERWIDTH, CopyFromParent, InputOutput,
			    CopyFromParent, valuemask, &attributes);

xptestgc = XCreateGC(mydisplay, topwindow, 0, 0);
XSetBackground(mydisplay, xptestgc, BLACK);

myhint.min_width = MINWIDTH;
myhint.min_height = MINHEIGHT;
myhint.flags |= PMinSize;
myhint.min_aspect.x = MINASPECTWIDTH;
myhint.min_aspect.y = MINASPECTHEIGHT;
myhint.max_aspect.x = MAXASPECTWIDTH;
myhint.max_aspect.y = MAXASPECTHEIGHT;
myhint.flags |= PAspect;

XSetStandardProperties(mydisplay, topwindow, Title, Title, iconpixmap,
			 argv, argc, &myhint);

myclass.res_name = "xkrs";
myclass.res_class = "Xkrs";
XSetClassHint(mydisplay, topwindow, &myclass);

valuemask = 0;
if (DefaultDepth(mydisplay, myscreen) == 1)
	{
	unsigned int w, h, w_8;
	char *data;

	XQueryBestStipple(mydisplay, topwindow, 8, 8, &w, &h);
	if (w & 1) w *= 2;
	if (h & 1) h *= 2;
	w_8 = (w + 7) / 8;
	data = malloc(w_8 * h);
	for (j = 0; j < h; j++)
      for (i = 0; i < w_8; i++) data[j * w_8 + i] = ((j & 1) ? 0xaa : 0x55);
/*
	bgpixmap = XCreateBitmapFromData(mydisplay, topwindow, data, w, h);
	attributes.background_pixmap = bgpixmap;
*/
	valuemask |= CWBackPixmap;
	free(data);
	}
 else
	{
	attributes.background_pixel = BLACK;
	valuemask |= CWBackPixel;
	}

valuemask = 0;
attributes.background_pixel = WHITE;
valuemask |= CWBackPixel;
attributes.border_pixel = BLACK;
valuemask |= CWBorderPixel;
attributes.event_mask = ButtonPressMask | ExposureMask;
valuemask |= CWEventMask;
attributes.override_redirect = True;
valuemask |= CWOverrideRedirect;
attributes.win_gravity = UnmapGravity;
valuemask |= CWWinGravity;

recalculate(myhint.width, myhint.height);

XMapSubwindows(mydisplay, topwindow);
XMapRaised(mydisplay, topwindow);

iicini();
cctini();

vidsel(2);/* select teletext decoder output to video output*/


while(1)
	{
	if(! test_video_signal(&video_signal_status) )exit(1);/*error*/
	if(video_signal_status) break;
	sleep(1);
	fprintf(stderr, "xkrs: No video signal\n");
	/*no exit here, up to user to correct*/
	/*signal user*/
	beep(1, 3000);
	delay(500);
	beep(1, 3000);
	delay(500);
	beep(1, 3000);
	}
printf("\nVideo signal ok");

/*if(! get_video_signal(present_channel) )
							/*this will try to set the vcr if no signal*/
/*	{
/*	printf("\nCannot arrange for video input, check hardware");
	/*no exit here, up to user to correct*/
	/*signal user*/
/*	beep(1, 3000);
/*	delay(500);
/*	beep(1, 3000);
/*	delay(500);
/*	beep(1, 3000);
/*	}
*/

/*
XFlush(mydisplay);
*/

/*
XDefineCursor(mydisplay, topwindow, cursor_normal);
*/
	
while (1)/* main loop */
	{
	if(! displaytxtpage() ) break;
	}/* end main while */
XCloseDisplay(mydisplay);
vidsel(4);/* saa output to video, so we can use pctv1000 to view tv */
exit(0);
}/* end main */


set_bit_port_to(int value)
{
int a;
a = inb(0x200);
if(value == 1)a |= 4;/* set bit 2  */
if(value == 0)a &= 255 - 4;/* reset bit 2 */
outb(a, 0x200);
return(1);
}
